<?php

$plugin_info = array(
'pi_name'			=> 'Weighted Categories',
'pi_version'		=> '1.11',
'pi_author'			=> 'Yvonne, runner',
'pi_author_url'		=> 'http://www.ennovy.org/index/weblog/comments/weighted_categories_plugin',
'pi_description'	=> 'Displays a weighted list of categories',
'pi_usage'			=> Weightedcategories::usage()
);

class Weightedcategories {

	var $return_data = "";

	// ----------------------------------------
	//  Weighted Categories
  	// ----------------------------------------

	function Weightedcategories()
	{
		global $TMPL, $DB, $FNS;
		
		// fetch parameters if any, otherwise use default
		$group_id 	= $TMPL->fetch_param('group_id')	? $TMPL->fetch_param('group_id')	: '';
		$weblog		= $TMPL->fetch_param('weblog')		? $TMPL->fetch_param('weblog')		: '';
		$min_font 	= $TMPL->fetch_param('min_font') 	? $TMPL->fetch_param('min_font') 	: '12';
		$max_font 	= $TMPL->fetch_param('max_font') 	? $TMPL->fetch_param('max_font') 	: '30';
		$backspace 	= $TMPL->fetch_param('backspace')	? $TMPL->fetch_param('backspace') 	: 0;
		$order_by	= $TMPL->fetch_param('order_by')	? $TMPL->fetch_param('order_by')	: '';
		$parent_id	= $TMPL->fetch_param('parent_id')	? $TMPL->fetch_param('parent_id')	: 0;
		$limit	= $TMPL->fetch_param('limit')	? $TMPL->fetch_param('limit')	: 255;
		
		// build query
		$group_id_str = '';
		if ( $group_id != '' ) {
			$count = 1;
			$group_ids = explode( '|', $group_id );
			foreach ( $group_ids as $cat ) {
				if ( $count == 1 ) {
					$group_id_str .= " AND ( exp_categories.group_id = '$cat'";
					$count++;
				} else {
					$group_id_str .= " OR exp_categories.group_id = '$cat'";
				}
			} // foreach
			$group_id_str .= " )";
		} // if 
		
		$weblog_str = '';
		if ( $weblog != '' ) {
			$count = 1; 
			$weblogs = explode( '|', $weblog );
			foreach ( $weblogs as $weblog_name ) {
				if ( $count == 1 ) {
					$weblog_str .= " AND ( exp_weblogs.blog_name = '$weblog_name'";
					$count++;
				}
				else {
					$weblog_str .= " OR exp_weblogs.blog_name = '$weblog_name'";
				}
			} // foreach
			$weblog_str .= " )";
		} //if 
		
		$order_by_str = '';
		if ( $order_by != '' ) {
			$order_by_str = " ORDER BY $order_by";
		}
		
		$parent_str = '';
		if ( $parent_id != 0 ) {
			$parent_str = " AND parent_id = $parent_id";
		}
		
		$sql = "SELECT count( exp_category_posts.entry_id ) AS count,
				exp_categories.cat_id,
				exp_categories.cat_name AS category,
				exp_categories.group_id,
				exp_weblogs.blog_name AS weblog
				FROM exp_categories, exp_category_posts, exp_weblogs, exp_weblog_titles
				WHERE exp_category_posts.cat_id = exp_categories.cat_id
				AND exp_categories.group_id = exp_weblogs.cat_group
				AND exp_category_posts.entry_id = exp_weblog_titles.entry_id
				AND exp_weblog_titles.weblog_id = exp_weblogs.weblog_id
				$group_id_str
				$weblog_str
        GROUP BY exp_categories.cat_id
				
				$order_by_str
        LIMIT $limit";
				
		// run query
		$query = $DB->query( $sql );
		
		// determine weights
		// code from http://dev.wp-plugins.org/file/weighted-category-list/weighted_categories.php?format=txt
		// and http://www.culture-makers.com/keywords/
		$cat_array = array();
		foreach ( $query->result as $row ) {
			$cat_array[$row['category']] = $row['count'];
		}		
		
		$spread = max($cat_array) - min($cat_array); 
		if ($spread <= 0) { $spread = 1; };
		$font_spread = $max_font - $min_font;
		$font_step = $spread / $font_spread;
		if ($font_spread <= 0) { $font_spread = 1; }
		
		foreach ( $query->result as $row ) {
			
			$tagdata = $TMPL->tagdata;
			
			// parse conditional pairs
			// code from system/modules/weblog/mod.weblog.php
			foreach( $TMPL->var_cond as $val ) {
                $cond = $FNS->prep_conditional($val['0']);
                $lcond	= substr($cond, 0, strpos($cond, ' '));
                $rcond	= substr($cond, strpos($cond, ' '));
                
                if ( isset($row[$val['3']]) ) {
                	$lcond = str_replace($val['3'], "\$row['".$val['3']."']", $lcond);
                	$cond = $lcond.' '.$rcond;
					$cond = str_replace("\|", "|", $cond);
					eval("\$result = ".$cond.";");
										
					if ($result) {
						$tagdata = str_replace($val['1'], $val['2'], $tagdata);                 
					}
					else {
						$tagdata = str_replace($val['1'], '', $tagdata);                 
					} 
                } // if
    		} // foreach
			
			// parse single variables
			foreach ( $TMPL->var_single as $key => $val ) {
				if ( $key == "font_size" ) {
					$tagdata = $TMPL->swap_var_single($val, ($min_font + round((($row['count']-1)/$font_step))), $tagdata);
				}
				if ( $key == "category" ) {
					$tagdata = $TMPL->swap_var_single($val, $row['category'], $tagdata);
				}
				if ( $key == "count" ) {
					$tagdata = $TMPL->swap_var_single($val, $row['count'], $tagdata);
				}
				if ( $key == "cat_id" ) {
					$tagdata = $TMPL->swap_var_single($val, $row['cat_id'], $tagdata);
				}
				if ( $key == "group_id" ) {
					$tagdata = $TMPL->swap_var_single($val, $row['group_id'], $tagdata);
				}
				if ( $key == "weblog" ) {
					$tagdata = $TMPL->swap_var_single($val, $row['weblog'], $tagdata);
				}
				if ( $key == "limit" ) {
					$tagdata = $TMPL->swap_var_single($val, $row['limit'], $tagdata);
				}
    		} // foreach
    		
    		$this->return_data .= $tagdata;
    		
		} // foreach
		
		// backspace
		if ( $backspace > 0 ) {
			$this->return_data = substr( $this->return_data, 0, (0-$backspace) );
		}
		
	} // Weightedcategories

	// ----------------------------------------
	//  Plugin Usage
  	// ----------------------------------------

	// This function describes how the plugin is used.
	//  Make sure and use output buffering

  	function usage()
  	{
  	ob_start(); 
  	?>
----------------------------------------  	
ABOUT
----------------------------------------

This plugin will display a linear list of the weighted categories. The categories are weighted on the number of entries assigned to the category.

----------------------------------------
PARAMETERS
----------------------------------------

group_id - the id of the category group you want to display. To figure out the id number of a category group, look in the exp_category_groups table. You can include several category groups by separating them with the pipe | character. If you have a category group assigned to multiple weblogs, the plugin will count entries from all of the weblogs.

weblog - the short name of the weblog you want to display (the plugin will limit the categories shown to those in the weblog). You can include several weblogs by separating them with the pipe | character.

min_font - size of the smallest category (category with the least number of entries). The default value is 12.

max_font - size of the largest category (category with the most number of entries). The default value is 30.

backspace - the number of characters that you want to chop off the end of the display.

order_by - how you want to sort the categories. Valid options for this parameter are 'count', 'cat_id', 'category', 'group_id', and 'weblog'. The default sort order is by group_id. By default, the list will not be sorted.

limit - how many categories you want to show. Defaults to 255

----------------------------------------
VARIABLES
----------------------------------------

SINGLE VARIABLES
{category} - the name of the category.
{cat_id} - the id of the category.
{count}	- the number of entries in the category.
{font_size} - the weighted font size.
{group_id} - the id of the category group that the category belongs to. 
{weblog} - the short name of the weblog.

Note: the {weblog} variable may not be accurate if you used the group_id parameter when calling the plugin. This is because when you use the group_id parameter, it counts the number of entries in each category of a category group from all weblogs, and not just one weblog. It will not be accurate if you specify several weblogs using the weblog parameter, and these weblog have the same category group. It is accurate only if each category group is assigned to one weblog.

CONDITIONAL VARIABLES
All of the single variables above can be used in a conditional statement.

----------------------------------------
EXAMPLE
----------------------------------------

The following will display an alphabetical weighted list of categories from one weblog:
{exp:weightedcategories weblog="weblog1" min_font="10" max_font="20" backspace="3" order_by="category"}
<span style="font-size: {font_size}px;" title="{count} entries"><a href="{path="weblog/index"}C{cat_id}">{category}</a></span> - {/exp:weightedcategories}

The following will display an alphabetical weighted list of categories from two weblogs, with a different output depending on the weblog:
{exp:weightedcategories weblog="weblog1|weblog2" min_font="10" max_font="20" backspace="3" order_by="category"}
{if weblog=="weblog1"}
<span style="font-size: {font_size}px;" title="{count} entries"><a href="{path="weblog/index"}C{cat_id}">{category}</a></span> - 
{/if}
{if weblog=="weblog2"}
<span style="font-size: {font_size}px;" title="{count} entries"><a href="{path="weblog2/index"}C{cat_id}">{category}</a></span> - 
{/if}
{/exp:weightedcategories}

The following will display a weighted list of categories belonging to two category groups, with the categories from the first category group listed first:
{exp:weightedcategories group_id="1|2" min_font="10" max_font="20" order_by="group_id"}
<span style="font-size: {font_size}px;" title="{count} entries">{category} ({count})</span>
{/exp:weightedcategories}

	<?php
	$buffer = ob_get_contents();
		
	ob_end_clean(); 

	return $buffer;
	}
	

	// END

} 	

?>